SystemOrganization addCategory: #'Mabinogi-Web'!

WAComponent subclass: #MbTable
	instanceVariableNames: 'values items columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:22'!
addColumn: aColumnDefinition
	columns add: aColumnDefinition! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:19'!
addColumns: aCollectionOrObject
	aCollectionOrObject isCollection 
		ifTrue: [ aCollectionOrObject do:  [ :i | self addColumn: i ]]
		ifFalse: [ aCollectionOrObject mbDefinitions do: [ :def | self addColumn: (MbTableColumn forDefinition: def) ] ]! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:28'!
initialize
	super initialize.
	items := #().
	columns := OrderedCollection new! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:26'!
items: aCollection
	items := aCollection! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:29'!
renderContentOn: html
	html table: [
		self renderHeadingsOn: html.
		items do: [ :item | self renderItem: item on: html]]! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:19'!
renderHeadingsOn: html
	html tableRow: [ 
		columns do: [ :c | c renderHeadingOn: html ]]! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:21'!
renderItem: anObject on: html
	html tableRow: [
		columns do: [ :c | c renderItem: anObject on: html ]]! !

WAComponent subclass: #MbValidatedComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

MbValidatedComponent subclass: #MbField
	instanceVariableNames: 'definition model value messages onChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

MbField subclass: #MbDateField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

!MbDateField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:09'!
supportedRenderHints
	^#(datePicker)! !

!MbDateField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:23'!
renderFieldOn: html
	| id |
	html label
		for: (id := html nextId);
		with: definition label.
	html textInput
		id: id;
		script: (html jQuery new datepicker 
	         onSelect: (html jQuery ajax serializeThis);
		   dateFormat: 'd MM yy');
		on: #value of: self.
! !

!MbDateField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:05'!
save
	definition setModelValue: value asDate! !

MbField subclass: #MbDropdownField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

!MbDropdownField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:01'!
supportedRenderHints
	^#(dropDown)! !

!MbDropdownField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:42'!
renderFieldOn: html
	| id select |
	html label
		for: (id := html nextId);
		with: definition label.
	select := html select
		id: id;
		on: #value of: self;
		list: definition values.
	definition required ifFalse: [ select beOptional  ]! !

!MbField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:54'!
definition: aDefinition model: anObject
	^(self findClassFor: aDefinition) 
		ifNotNil: [ :c | c definition: aDefinition model: anObject	]
		ifNil: [ self basicNew
			initializeWithDefinition: aDefinition model: anObject;
			yourself]! !

!MbField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:00'!
findClassFor: aDefinition
	^self allSubclasses detect: [ :fieldClass | fieldClass supports: aDefinition ] ifNone: [nil]! !

!MbField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:57'!
supportedRenderHints
	^#()! !

!MbField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:57'!
supports: aDefinition
	^self supportedRenderHints includes: aDefinition renderHint! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 20:24'!
initializeWithDefinition: aDefinition model: anObject
	self initialize.
	definition := aDefinition.
	model := anObject.
	messages := #().
	self reset.
	onChange := [ :v | ]
! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:06'!
messages
	^messages! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 20:24'!
onChange: aBlock
	onChange := aBlock! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:04'!
renderContentOn: html
	html div
		class: #mbField;
		class: #mbInvalid if: self valid not;
		with: [ self renderFieldOn: html ]! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:04'!
renderFieldOn: html
	| id |
	html label
		for: (id := html nextId);
		with: definition label.
	^ html textInput
		id: id;
		on: #value of: self! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:10'!
reset
	value := model copy.! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:10'!
save
	definition setModelValue: value ! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:45'!
valid
	^messages isEmpty! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:02'!
validate
	[ definition assertValid: value.
		messages := #() ] on: MbValidationError do: [ :e | messages := Array with: e message ].
! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/28/2012 09:31'!
value
	^value! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 20:24'!
value: aValue
	value := aValue.
	self validate.
	onChange value: aValue! !

MbField subclass: #MbNumericField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

!MbNumericField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:25'!
supports: aDefinition
	^aDefinition typeHint = #numeric! !

!MbNumericField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:30'!
renderFieldOn: html
	| id |
	html label
		for: (id := html nextId);
		with: (definition label).
	definition currency ifNotNilDo: [ :c | html render: c ].
	html textInput
		id: id;
		on: #value of: self.
! !

!MbNumericField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:32'!
save
	definition setModelValue: (definition precision 
		ifNil: [ Number readFrom: value ]
		ifNotNil: [ :p | (Number readFrom: value) asScaledDecimal: p])! !

MbValidatedComponent subclass: #MbForm
	instanceVariableNames: 'model fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

!MbForm class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/28/2012 08:11'!
on: anObject
	^self basicNew
		initializeWithObject: anObject;
		yourself! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:16'!
cancel
	self answer: nil! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 19:08'!
children
	^fields values! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 19:17'!
initializeWithObject: anObject
	self initialize.
	model := anObject.
	fields := (model mbDefinitions 
		collect: [ :def | def selector -> (MbField definition: def model: (anObject perform: def selector))]) asDictionary! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 19:11'!
renderContentOn: html
	html form
		defaultAction: [ self save ];
		with: [ self renderFieldsOn: html. 
			html div: [ html submitButton
				callback: [ self save ];
				value: 'Save'.
			html space.
			html cancelButton
				value: 'Cancel';
				callback: [ self cancel ] ] ]! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 19:11'!
renderFieldsOn: html
	fields values
		do: [ :f | 
			html render: f.
			f valid
				ifFalse: [ f messages do: [ :m | html paragraph: m ] ] ]! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 21:10'!
save
	self valid ifTrue: [
		fields do: [ :f | f save ].
		self answer: model]! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:47'!
valid
	^fields allSatisfy: [ :f | f valid]! !

!MbValidatedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:43'!
messages
	"Returns a collection of error messages for the component"
	^#()! !

!MbValidatedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:07'!
save
! !

!MbValidatedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:40'!
valid
	^false! !

Object subclass: #MbTableColumn
	instanceVariableNames: 'valueBlock heading'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

!MbTableColumn class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:12'!
forDefinition: aDefinition
	^self new
		heading: aDefinition label;
		valueBlock: [ :item | (item mbDefinitionFor: (aDefinition selector)) printValue ];
		yourself.! !

!MbTableColumn class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:00'!
forSelector: aSymbol
	^self new
		heading: aSymbol asCapitalizedPhrase;
		valueBlock: [ :item | item perform: aSymbol ];
		yourself.! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:57'!
heading
	^heading! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:57'!
heading: aString
	heading := aString! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:45'!
renderHeadingOn: html
	html tableHeading: self heading! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:55'!
renderItem: anObject on: html
	html tableData: [
		html render: (self valueForItem: anObject)]! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:00'!
valueBlock: aOneArgumentBlock
	valueBlock := aOneArgumentBlock.! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:59'!
valueForItem: anObject
	^valueBlock value: anObject! !
